/*
 *  Citrusleaf Foundation
 *  include/clock.h - locking operations
 *
 *  Copyright 2008 by Citrusleaf.  All rights reserved.
 *  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE.  THE COPYRIGHT NOTICE
 *  ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
 */
#pragma once

#include <stdint.h>

/* Timekeeping */
typedef uint64_t cf_clock;
extern cf_clock cf_getms();
extern cf_clock cf_clock_getabsolute();
extern cf_clock cf_get_seconds();

inline static uint64_t
TIMESPEC_TO_MS_P( struct timespec *ts )
{
    uint64_t r1 = ts->tv_nsec;
    r1 /= 1000000;
    uint64_t r2 = ts->tv_sec;
    r2 *= 1000;
    return( r1 + r2 );
}

inline static uint64_t
TIMESPEC_TO_MS( struct timespec ts )
{
    uint64_t r1 = ts.tv_nsec;
    r1 /= 1000000;
    uint64_t r2 = ts.tv_sec;
    r2 *= 1000;
    return ( r1 + r2 );
}

inline static void
TIMESPEC_ADD_MS(struct timespec *ts, uint64_t ms)
{
    ts->tv_sec += ms / 1000;
    ts->tv_nsec += (ms % 1000) * 1000000;
    if (ts->tv_nsec > 1000000000) {
        ts->tv_sec ++;
        ts->tv_nsec -= 1000000000;
    }
}


